package no.vestein.rtree.lsm;


public abstract class BaseNode2D {
  public float xl, xh, yl, yh;
  public long lhv = 0;

  protected BaseNode2D(float xl, float xh, float yl, float yh) {
    this.xl = xl;
    this.xh = xh;
    this.yl = yl;
    this.yh = yh;
  }

  protected BaseNode2D(float xl, float xh, float yl, float yh, long lhv) {
    this(xl, xh, yl, yh);
    this.lhv = lhv;
  }

  public void updateLhv(long lhv) {
    this.lhv = Math.max(this.lhv, lhv);
  }

  public void updateDimension(float nxl, float nxh, float nyl, float nyh) {
    xl = Math.min(xl, nxl);
    yl = Math.min(yl, nyl);
    xh = Math.max(xh, nxh);
    yh = Math.max(yh, nyh);
  }

  public void updateDimension(BaseNode2D node) {
    updateDimension(node.xl, node.xh, node.yl, node.yh);
  }

  public void setData(BaseNode2D node) {
    xl = node.xl;
    xh = node.xh;
    yl = node.yl;
    yh = node.yh;
    lhv = node.lhv;
  }

  abstract int getSize();

}
