package no.vestein.rtree.lsm;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

public class Buffer {
  private static final Comparator<Entry> comparator = new Comparator<Entry>() {
    @Override
    public int compare(Entry o1, Entry o2) {
      return Long.compareUnsigned(o1.lhv, o2.lhv);
    }
  };
  private final int CAPACITY;
  private final List<Entry> entries;

  public Buffer(final int capacity) {
    this.CAPACITY = capacity;
    entries = new ArrayList<>(capacity);
  }

  public void add(Entry entry) {
    entries.add(entry);
  }

  public boolean isFull() {
    return entries.size() >= CAPACITY;
  }

  public void clear() {
    entries.clear();
  }


  public List<Entry> getSorted() {
    entries.sort(comparator);
    return entries;
  }

}
