package no.vestein.rtree.lsm;

import no.vestein.rtree.lsm.cuda.CRandom;
import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Random;

public class Test {

  public static void cleanFolder(String folder) {
    try {
      File dir = new File(folder);
      if (dir.exists()) {
        FileUtils.deleteDirectory(dir);
      }
      while (dir.exists()) {
        try {
          Thread.sleep(1);
        } catch (InterruptedException e) {

        }
      }
      FileUtils.forceMkdir(dir);
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  public static void writeStats(String filename) {
    try {
      PrintWriter writer = new PrintWriter(new File(filename));

      //writer.println(String.format("Writes: %d", Stats.writes.get()));
      //writer.println(String.format("Reads: %d", Stats.reads.get()));
      writer.println(String.format("Time: %d", Stats.time.get()));

      writer.close();
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  public static class EntrySet {
    public final LinkedList<Entry> entries = new LinkedList<>();
  }

  public static class NormalEntrySet extends EntrySet {

    public NormalEntrySet(long seed, int numberOfElements, int factor) {
      System.out.println("Generating dataset...");

      float[] xdim = CRandom.generateUniformRandomFloats(numberOfElements * factor, seed);
      //float[] ydim = CRandom.generateRandomFloats(numberOfElements, seed*2);

      float xl, yl;
      for (int i = 0; i < numberOfElements * factor; i += factor) {
        xl = 0;
        yl = 0;
        for (int j = 0; j < factor/2; j++) {
          xl += xdim[i + j];
          yl += xdim[i + j + factor/2];
        }
        xl = xl / (factor / 2) * 180 - 90;
        yl = yl / (factor / 2) * 360 - 180;
//        xl = (xdim[i] + xdim[i+1])/2 * 180 - 90;
//        yl = (xdim[i+2] + xdim[i+3])/2 * 360 - 180;
        entries.add(new Entry(xl, xl, yl, yl));
      }
      System.out.println("Dataset generated!");
    }

  }

  public static class UniformEntrySet extends EntrySet {
    private Random rand;

    public UniformEntrySet(long seed, int numberOfElements) {
      rand = new Random(seed);

      System.out.println("Generating dataset...");
      float xl, yl;
      for (int i = 0; i < numberOfElements; i++) {
        xl = rand.nextFloat() * 180 - 90;
        yl = rand.nextFloat() * 360 - 180;
        entries.add(new Entry(xl, xl, yl, yl));
      }
      System.out.println("Dataset generated!");
    }

  }

}
