package no.vestein.rtree.pre;

import no.vestein.rtree.lsm.BitMagic;

import java.util.TreeSet;


public class Node {
  public int xl, xh, yl, yh;
  public final boolean isLeaf;
  public boolean isEntry = false;
  public TreeSet<Node> children = new TreeSet<>(IO.comparator);
  public String childrenFilePath = Integer.toString(BitMagic.COUNTER.incrementAndGet());
  public String filePath;
  public Node parent;
  public Node neighbor;

  int lhv = 0;

  public Node(boolean isLeaf) {
    this.isLeaf = isLeaf;
  }

  public Node(int xl, int yl, int xh, int yh) {
    this(xl, yl, xh, yh, true);
    isEntry = true;
  }

  public Node(int xl, int yl, int xh, int yh, boolean isLeaf) {
    this.xl = xl;
    this.xh = xh;
    this.yl = yl;
    this.yh = yh;
    this.isLeaf = isLeaf;
  }

  public void setData(Node node) {
    xl = node.xl;
    yl = node.yl;
    xh = node.xh;
    yh = node.yh;
    lhv = node.lhv;
  }

  public boolean updateDataIff(Node node) {
    if (lhv < node.lhv || xl > node.xl || yl > node.yl || xh < node.xh || yh < node.yh) {
      lhv = Math.max(lhv, node.lhv);
      xl = Math.min(xl, node.xl);
      yl = Math.min(yl, node.yl);
      xh = Math.max(xh, node.xh);
      yh = Math.max(yh, node.yh);
      return true;
    }
    return false;
  }

  public void addChild(Node node) {
    children.add(node);
    node.parent = this;
    xl = Math.min(xl, node.xl);
    yl = Math.min(yl, node.yl);
    xh = Math.max(xh, node.xh);
    yh = Math.max(yh, node.yh);
    lhv = Math.max(lhv, node.lhv);
  }

}
