#!/bin/bash

export JAVA_RTREE_OPTS=-Xmx12g

runTest() {
	echo "zpool-buffer-bs$1-recordsize128k"
	./rtree2/bin/java-rtree -n 100000000 -rbs $2 -wbs $2 -b 1048576 -f 8 -s 1337 -curve Z -draw -tag linux -runs 1 -levels 4 -bt 2 -bmt 2 -mt 1 -mstrat stream -rf 4 > output-zpool-buffer-bs$1-recordsize128k.log 2>&1 &
	zpool iostat fastpool 1 540 > zpool-buffer-bs$1-recordsize128k.log 2>&1 &
	sleep 540
}

runTest "512" "512"
runTest "1k" "1024"
runTest "2k" "2048"
runTest "4k" "4096"
runTest "8k" "8192"
runTest "16k" "16384"
runTest "32k" "32768"
runTest "64k" "65536"
runTest "128k" "131072"
runTest "256k" "262144"
runTest "512k" "524288"
runTest "1m" "10348576"

echo "!!DONE H BT!!"
